package org.rcisoft.bus.bcustomer.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.rcisoft.bus.bcustomer.entity.BCustomer;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.aop.CyPageUtilAsp;
import org.rcisoft.core.model.CyPageInfo;

import java.util.List;

/**
 * Created by cy on 2024年5月11日 下午3:19:37.
 */
public interface BCustomerService {

    /**
    * 保存 
    * @param bCustomer
    * @return
    */
    CyPersistModel persist(BCustomer bCustomer);

    /**
    * 删除 
    * @param bCustomer
    * @return
    */
    CyPersistModel remove(BCustomer bCustomer);
    /**
    * 逻辑删除 
    * @param bCustomer
    * @return
    */
    CyPersistModel removeLogical(BCustomer bCustomer);
    /**
    * 修改 
    * @param bCustomer
    * @return
    */
    CyPersistModel merge(BCustomer bCustomer);

    /**
    * 根据id查询 
    * @param id
    * @return
    */
    BCustomer findById(String id);

    /**
    * 分页查询 
    * @param bCustomer
    * @return
    */
    IPage<BCustomer> findAllByPagination(CyPageInfo<BCustomer> paginationUtility,
              BCustomer bCustomer);


    /**
    * 查询list 
    * @param bCustomer
    * @return
    */
    List<BCustomer> findAll(BCustomer bCustomer);


    /**
    * 导出
    * @return
    */
    List<BCustomer> export(BCustomer bCustomer);

}
