package org.rcisoft.bus.jnsp7xtm.controller;

import io.swagger.annotations.ApiOperation;
import org.rcisoft.bus.jnsp7xtm.dto.Jnsp7xtmPageRequestDto;
import org.rcisoft.bus.jnsp7xtm.entity.Jnsp7xtm;
import org.rcisoft.bus.jnsp7xtm.service.Jnsp7xtmService;
import org.rcisoft.core.anno.CyOpeLogAnno;
import org.rcisoft.core.controller.CyPaginationController;
import org.rcisoft.core.model.CyGridModel;
import org.rcisoft.core.operlog.enums.CyLogTypeEnum;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;

/**
 * @Author: gy
 * @Date: 2024/5/9 14:04
 * @Description: Jnsp74tm controlle层
 */
@RestController
@RequestMapping("/Jnsp7xtm")
public class Jnsp7xtmController extends CyPaginationController<Jnsp7xtm> {

    @Autowired
    private Jnsp7xtmService jnsp74tmService;

    /**
     * 7.弹出框查询
     * **/
    @CyOpeLogAnno(title = "system-入库记录管理-查询入库记录", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value="分页查询入库记录集合", notes="分页查询入库记录集合")
    @GetMapping(value = "/queryJnsp74tmByPaged")
    public CyGridModel listByPagination(Jnsp7xtmPageRequestDto jnsp74tmPageRequestDto) {
        jnsp74tmService.findAllByPagination(getPaginationUtility(), jnsp74tmPageRequestDto);
        return getGridModelResponse();
    }

    /** 8.导出弹出框中的数据**/
    @CyOpeLogAnno(title = "system-Jnsp7xtm管理-导出详细信息", businessType = CyLogTypeEnum.EXPORT)
    @ApiOperation(value = "导出详细信息", notes = "导出详细信息")
    @GetMapping (value = "/exportUserDetailJnsp74tm")
    public void exportUserDetailJnsp74tm(HttpServletResponse response, Jnsp7xtmPageRequestDto jnsp74tmPageRequestDto, @PathVariable @RequestParam(defaultValue = "0") String excelId) {
        String excelName = "";
        switch (excelId) {
            case "0":
                excelName = "Jnsp7xtm信息.xls";
                break;
            case "1":
                excelName = "Jnsp7xtm信息.xlsx";
                break;
            case "2":
                excelName = "Jnsp7xtm信息.csv";
                break;
        }
        jnsp74tmService.exportUserDetailJnsp74tm(jnsp74tmPageRequestDto,excelName,response);
    }

    /** 9.导出弹出框中的数据**/
    @CyOpeLogAnno(title = "system-Jnsp7xtm管理-导出明细信息", businessType = CyLogTypeEnum.EXPORT)
    @ApiOperation(value = "导出明细信息", notes = "导出明细信息")
    @GetMapping(value = "/exportDetailJnsp74tm")
    public void exportDetailJnsp74tm(HttpServletResponse response, Jnsp7xtmPageRequestDto jnsp74tmPageRequestDto, @PathVariable @RequestParam(defaultValue = "0") String excelId) {
        String excelName = "";
        switch (excelId) {
            case "0":
                excelName = "Jnsp7xtm信息.xls";
                break;
            case "1":
                excelName = "Jnsp7xtm信息.xlsx";
                break;
            case "2":
                excelName = "Jnsp7xtm信息.csv";
                break;
        }
        jnsp74tmService.exportDetailJnsp74tm(jnsp74tmPageRequestDto,excelName,response);
    }

    /**
     * 10.统计导出
     * **/
    @CyOpeLogAnno(title = "system-Jnsp7xtm管理-导出统计信息", businessType = CyLogTypeEnum.EXPORT)
    @ApiOperation(value = "导出统计信息", notes = "导出统计信息")
    @GetMapping(value = "/exportTotal")
    public void exportTotal(HttpServletResponse response, Jnsp7xtmPageRequestDto jnsp74tmPageRequestDto, @PathVariable @RequestParam(defaultValue = "0") String excelId) {
        String excelName = "";
        switch (excelId) {
            case "0":
                excelName = "Jnsp7xtm信息.xls";
                break;
            case "1":
                excelName = "Jnsp7xtm信息.xlsx";
                break;
            case "2":
                excelName = "Jnsp7xtm信息.csv";
                break;
        }
        jnsp74tmService.exportTotal(response,jnsp74tmPageRequestDto);
    }
}
