package org.rcisoft.bus.jnsp7xtm.controller;

import io.swagger.annotations.ApiOperation;
import org.rcisoft.bus.jnsp7xtm.dto.Jnsp7xtmPageRequestDto;
import org.rcisoft.bus.jnsp7xtm.entity.Jnsp7xtm;
import org.rcisoft.bus.jnsp7xtm.service.Jnsp7xtmStatisticService;
import org.rcisoft.core.anno.CyOpeLogAnno;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.operlog.enums.CyLogTypeEnum;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyResultGenUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Author: gy
 * @Date: 2024/5/7 13:15
 * @Description: 查询统计controller层
 */
@RestController
@RequestMapping("/jnsp7xtmStatistics")
public class Jnsp7xtmStatisticsController {

    @Autowired
    private Jnsp7xtmStatisticService jnsp74tmStatisticService;

    //  1.查询所有下拉框数据源
    @CyOpeLogAnno(title = "system-DemoData1管理-查询高级搜索", businessType = CyLogTypeEnum.OTHER)
    @ApiOperation(value = "查询下拉框数据源", notes = "查询下拉框数据源")
    @GetMapping("/queryAllPullDown")
    public CyResult queryAllPullDown(Jnsp7xtmPageRequestDto jnsp74tmPageRequestDto) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jnsp74tmStatisticService.queryAllPullDownData(jnsp74tmPageRequestDto));
    }

    // 2.实施查询搜索框数据
    @CyOpeLogAnno(title = "system-DemoData1管理-查询高级搜索", businessType = CyLogTypeEnum.OTHER)
    @ApiOperation(value = "查询下拉框数据源", notes = "查询下拉框数据源")
    @GetMapping("/queryKey")
    public CyResult queryKey(Jnsp7xtm Jnsp74tm) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jnsp74tmStatisticService.queryKey(Jnsp74tm));
    }

    // 3.查询统计
    @CyOpeLogAnno(title = "system-DemoData1管理-查询统计", businessType = CyLogTypeEnum.OTHER)
    @ApiOperation(value = "查询统计", notes = "查询统计")
    @GetMapping("/getPageList")
    public CyResult getPageList(Jnsp7xtmPageRequestDto jnsp74tmPageRequestDto) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jnsp74tmStatisticService.getPageList(jnsp74tmPageRequestDto));
    }

    // 4.查询合计
    @CyOpeLogAnno(title = "system-DemoData1管理-查询统计", businessType = CyLogTypeEnum.OTHER)
    @ApiOperation(value = "查询统计", notes = "查询统计")
    @GetMapping("/queryTotal")
    public CyResult queryTotal(Jnsp7xtmPageRequestDto jnsp74tmPageRequestDto) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jnsp74tmStatisticService.queryTotal(jnsp74tmPageRequestDto));
    }

}
