package org.rcisoft.bus.jnsp7xtm.dao;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.rcisoft.bus.jnsp7xtm.dto.Jnsp7xtmPageRequestDto;
import org.rcisoft.bus.jnsp7xtm.dto.Jnsp7xtmDto;
import org.rcisoft.bus.jnsp7xtm.entity.Jnsp7xtm;

import java.util.List;
import java.util.Map;

/**
 * Jnsp74tm统计mapper
 * **/
@Mapper
public interface Jnsp7xtmStatisticsRepository {

    // 1.查询全部下拉数据
    List<String> queryAllPullDown(@Param("key") String key);

    // 2.实时查询搜索框
    List<Jnsp7xtm> queryKey(Jnsp7xtm jnsp74tm);

    // 3.获取月份
    List<String> getMonths();

    // 4.获取统计总条数
    List<Map<String,Object>> queryStatisticsCount(@Param("entity") Jnsp7xtmPageRequestDto jnsp74tmPageRequestDto, @Param("monthList") String months, @Param("statistics") String statistics,@Param("orderColumn")String orderColumn,@Param("joinSql") String joinSql);

    /**
     * @description: 5.获取统计list
     * @author: gaoyu
     * @param:  requestDto - 前端筛选项
     * @param:  monthList - 月份
     * @param:  pageNo - 当前页
     * @param:  pageSize - 页数
     * @param:  isPage - 是否分页 1:分页
     * @param:  computedColumn - 计算列
     * @return:
     **/
    List<Map<String,Object>> queryList(@Param("entity") Jnsp7xtmPageRequestDto jnsp74tmPageRequestDto, @Param("monthList") String months, @Param("pageNo") int pageNo, @Param("pageSize") int pageSize, @Param("isPage") String isPage, @Param("computedColumn") String computedColumn, @Param("statistics") String statistics,@Param("orderColumn")String orderColumn,@Param("joinSql") String joinSql);

    // 6 查询合计接口
    List<Jnsp7xtmDto> queryTotal(@Param("entity") Jnsp7xtmPageRequestDto jnsp74tmPageRequestDto);


}
