package org.rcisoft.bus.jnsp7xtm.dto;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Data;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Author: gy
 * @Date: 2024/5/7 14:46
 * @Description:  合计统计数据类
 */
@Data
public class Jnsp7xtmPageDto implements Serializable {

    // 维度1
    private String dimensionalityOne;

    // 维度2
    private String dimensionalityTwo;

    // 维度3
    private String dimensionalityThree;

    private List<Jnsp7xtmDto> data;


    @JsonIgnore
    private Map<String,Integer> map;

    public Jnsp7xtmPageDto(String dimensionalityOne, String dimensionalityTwo, String dimensionalityThree, List<String> list, boolean[] flag) {
        this.map = new HashMap();
        this.dimensionalityOne = dimensionalityOne;
        this.dimensionalityTwo = dimensionalityTwo;
        this.dimensionalityThree = dimensionalityThree;
        this.data = new ArrayList<>(list.size());
        for (int i = 0; i < list.size(); i++) {
            Jnsp7xtmDto infromation = new Jnsp7xtmDto();
            infromation.setNqy(list.get(i));
            if (flag[0]){
                infromation.setXsjg("");
            }
            if (flag[1]){
                infromation.setRmb("");
            }
            if (flag[2]){
                infromation.setChzs("");
            }
            if (flag[3]) {
                infromation.setChzsa("");
            }
            if (flag[4]) {
                infromation.setChzsb("");
            }
            if (flag[5]) {
                infromation.setZzc("");
            }
            if (flag[6]) {
                infromation.setZzcg("");
            }
            this.data.add(infromation);
            map.put(list.get(i),i);
        }

    }


}
