package org.rcisoft.bus.jnsp7xtmdqsj.controller;


/*固定导入*/
import cn.afterturn.easypoi.excel.ExcelExportUtil;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.core.anno.CyOpeLogAnno;
import org.rcisoft.core.operlog.enums.CyLogTypeEnum;
import org.rcisoft.core.util.CyEpExcelUtil;
import org.rcisoft.util.ExportToExcelUtil;
import org.springframework.validation.BindingResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyResultGenUtil;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.controller.CyPaginationController;
import org.rcisoft.core.util.CyUserUtil;
import org.rcisoft.core.model.CyGridModel;
import org.rcisoft.core.exception.CyServiceException;
import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;


import org.rcisoft.bus.jnsp7xtmdqsj.entity.Jnsp7xtmDqsj;
import org.rcisoft.bus.jnsp7xtmdqsj.service.Jnsp7xtmDqsjService;

import java.util.List;

/**
* Created by cy on 2024年5月14日 上午10:20:48.
*/
@RestController
@RequestMapping("/jnsp7xtmdqsj")
public class Jnsp7xtmDqsjController extends CyPaginationController<Jnsp7xtmDqsj> {


    @Autowired
    private Jnsp7xtmDqsjService jnsp7xtmDqsjServiceImpl;

    //@PreAuthorize("@cyPerm.hasPerm('sys:p7xtmDqsj:add')")
    @CyOpeLogAnno(title = "system-Jnsp7xtmDqsj管理-新增Jnsp7xtmDqsj", businessType = CyLogTypeEnum.INSERT)
    @ApiOperation(value="添加Jnsp7xtmDqsj", notes="添加Jnsp7xtmDqsj")
    @PostMapping(value = "/add")
    public CyResult add(@Valid Jnsp7xtmDqsj jnsp7xtmDqsj, BindingResult bindingResult) {
        CyPersistModel data = jnsp7xtmDqsjServiceImpl.persist(jnsp7xtmDqsj);
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        jnsp7xtmDqsj);
    }
    //@PreAuthorize("@cyPerm.hasPerm('sys:p7xtmDqsj:delete')")
    @CyOpeLogAnno(title = "system-Jnsp7xtmDqsj管理-删除Jnsp7xtmDqsj", businessType = CyLogTypeEnum.DELETE)
    @ApiOperation(value="删除Jnsp7xtmDqsj", notes="删除Jnsp7xtmDqsj")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = true, dataType = "varchar")})
    @DeleteMapping("/delete/{businessId:\\w+}")
    public CyResult delete(@PathVariable int businessId,Jnsp7xtmDqsj jnsp7xtmDqsj) {
        jnsp7xtmDqsj.setBusinessId(businessId);
        CyPersistModel data = jnsp7xtmDqsjServiceImpl.remove(jnsp7xtmDqsj);
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        businessId);
    }

    //@PreAuthorize("@cyPerm.hasPerm('sys:p7xtmDqsj:update')")
    @CyOpeLogAnno(title = "system-Jnsp7xtmDqsj管理-修改Jnsp7xtmDqsj", businessType = CyLogTypeEnum.UPDATE)
    @ApiOperation(value="修改Jnsp7xtmDqsj", notes="修改Jnsp7xtmDqsj")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
    @PutMapping("/update/{businessId:\\w+}")
    public CyResult update(@PathVariable int businessId, @Valid Jnsp7xtmDqsj jnsp7xtmDqsj, BindingResult bindingResult) {
        jnsp7xtmDqsj.setBusinessId(businessId);
        CyPersistModel data = jnsp7xtmDqsjServiceImpl.merge(jnsp7xtmDqsj);
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        jnsp7xtmDqsj);
    }

    //@PreAuthorize("@cyPerm.hasPerm('sys:p7xtmDqsj:query')")
    @CyOpeLogAnno(title = "system-Jnsp7xtmDqsj管理-查询Jnsp7xtmDqsj", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value="查询单一Jnsp7xtmDqsj", notes="查询单一Jnsp7xtmDqsj")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = true, dataType = "varchar")})
    @GetMapping("/detail/{businessId:\\w+}")
    public CyResult detail(@PathVariable int businessId) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        jnsp7xtmDqsjServiceImpl.findById(businessId));
    }

    //@PreAuthorize("@cyPerm.hasPerm('sys:p7xtmDqsj:list')")
    @CyOpeLogAnno(title = "system-Jnsp7xtmDqsj管理-查询Jnsp7xtmDqsj", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value="查询Jnsp7xtmDqsj集合", notes="查询Jnsp7xtmDqsj集合")
    @GetMapping(value = "/listAll")
    public CyResult listAll(Jnsp7xtmDqsj jnsp7xtmDqsj) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
            jnsp7xtmDqsjServiceImpl.findAll(jnsp7xtmDqsj));
    }

    //@PreAuthorize("@cyPerm.hasPerm('sys:p7xtmDqsj:list')")
    @CyOpeLogAnno(title = "system-Jnsp7xtmDqsj管理-查询Jnsp7xtmDqsj", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value="分页查询Jnsp7xtmDqsj集合", notes="分页查询Jnsp7xtmDqsj集合")
    @GetMapping(value = "/list")
    public CyGridModel listByPagination(Jnsp7xtmDqsj jnsp7xtmDqsj) {
        jnsp7xtmDqsjServiceImpl.findAllByPagination(getPaginationUtility(), jnsp7xtmDqsj);
        return getGridModelResponse();
    }

    @CyOpeLogAnno(title = "system-Jnsp7xtmDqsj管理-查询Jnsp7xtmDqsj", businessType = CyLogTypeEnum.EXPORT)
    @ApiOperation(value = "导出Jnsp7xtmDqsj信息", notes = "导出Jnsp7xtmDqsj信息")
    @GetMapping(value = "/export")
    public void outJnsp7xtmDqsj(HttpServletResponse response,Jnsp7xtmDqsj jnsp7xtmDqsj,@PathVariable @RequestParam(defaultValue = "0") String excelId) {
        String excelName="";
        switch(excelId){
            case "0": excelName="Jnsp7xtmDqsj信息.xls";break;
            case "1": excelName="Jnsp7xtmDqsj信息.xlsx";break;
            case "2": excelName="Jnsp7xtmDqsj信息.csv";break;
        }
        List<Jnsp7xtmDqsj> jnsp7xtmDqsjList = jnsp7xtmDqsjServiceImpl.export(jnsp7xtmDqsj);
        ExportToExcelUtil.exportExcel(jnsp7xtmDqsjList, "Jnsp7xtmDqsj信息", "Jnsp7xtmDqsj信息", Jnsp7xtmDqsj.class, excelName, response);
    }

    @CyOpeLogAnno(title = "system-Jnsp7xtmDqsj管理-查询月份下拉框", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value = "查询月份下拉框", notes = "查询月份下拉框")
    @GetMapping(value = "/getMonth")
    public CyResult getMonth() {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jnsp7xtmDqsjServiceImpl.getMonth());
    }

    @CyOpeLogAnno(title = "system-Jnsp7xtmDqsj管理-数据表重置", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value = "数据表重置", notes = "数据表重置")
    @GetMapping(value = "/dataTableRese")
    public CyResult truncateTable(String key) {
        return CyResultGenUtil.builder(jnsp7xtmDqsjServiceImpl.dataTableRese(),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                null);
    }

    @CyOpeLogAnno(title = "system-Jnsp7xtmDqsj管理-月度表拉取", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value = "月度表拉取", notes = "月度表拉取")
    @PostMapping (value = "/monthlyTablePull")
    public CyResult monthlyTablePull() {
        return CyResultGenUtil.builder(jnsp7xtmDqsjServiceImpl.monthlyTablePull(),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                null);
    }
}
